/*
 *  ImgView  A simple image viewer
 *
 *  Copyright (C) 2013 Mats Peterson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  Please send any comments/bug reports to
 *  matsp888@yahoo.com  (Mats Peterson)
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "imgview.h"

static void getval(char *s1, char *s2)
{
    char tmp1[50], tmp2[256], *p;
    *tmp2 = '\0';
    memset(tmp2, 0, 256);
    sscanf(s1, "%s %255c", tmp1, tmp2);
    if (*tmp2 == '\0') {
        fprintf(stderr, "Invalid line `%s' in .imgviewrc\n", s1);
        exit(1);
    }
    for (p = tmp2 + strlen(tmp2) - 1; *p == ' ' || *p == '\t'; p--)
        *p = '\0';
    strcpy(s2, tmp2);
}

static void parse(FILE *f, char *s)
{
    if (! strncmp(s, "bgcolor ", 8))
        getval(s, v.bgcolor_s);
    else if (! strncmp(s, "tbgcolor ", 9))
        getval(s, v.tbgcolor_s);
    else if (! strncmp(s, "bwbgcolor ", 10))
        getval(s, v.bwbgcolor_s);
    else if (! strncmp(s, "bwfgcolor ", 10))
        getval(s, v.bwfgcolor_s);
    else if (! strncmp(s, "rgbprofile ", 11))
        getval(s, v.rgbprofile);
    else if (! strncmp(s, "grayprofile ", 12))
        getval(s, v.grayprofile);
    else if (! strncmp(s, "cmykprofile ", 12))
        getval(s, v.cmykprofile);
    else if (! strncmp(s, "outprofile ", 11))
        getval(s, v.outprofile);
}

void readconfig(FILE *f)
{
    char s[512];

    while (fgets(s, 512, f)) {
        s[strlen(s) - 1] = '\0';
        if (*s == '#' || *s == '\0') continue;
        parse(f, s);
    }
    fclose(f);
}
