/*
 *  ImgView  A simple image viewer
 *
 *  Copyright (C) 2013 Mats Peterson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  Please send any comments/bug reports to
 *  matsp888@yahoo.com  (Mats Peterson)
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <lcms2.h>
#include "imgview.h"

char *proftomem(cmsHPROFILE prof, cmsUInt32Number *len)
{
    char *buf = NULL;
    if (cmsSaveProfileToMem(prof, NULL, len)) {
        buf = (char *)malloc(*len);
        cmsSaveProfileToMem(prof, buf, len);
    }
    return buf;
}

int isoutprof(void)
{
    int retval = 0;
    if (cmsGetColorSpace(v.hInProfile) == cmsSigRgbData) {
        char *iprof;
        cmsUInt32Number iproflen;
        iprof = proftomem(v.hInProfile, &iproflen);
        retval = iprof && v.oprof && iproflen == v.oproflen &&
                !memcmp(iprof, v.oprof, iproflen);
        if (iprof) free(iprof);
    }
    return retval;
}
