#ifndef IMGVIEW_H
#define IMGVIEW_H

#include <xsimple.h>
#include <stdio.h>
#include <strutil.h>
#include <limits.h>
#include <locale.h>
#include <sys/stat.h>
#include <lcms2.h>

#define WIN_X 0
#define WIN_Y 0
#define WIN_W 0
#define WIN_H 0

#define BGCOLOR "black"
#define TBGCOLOR "#d9d9d9"

#define BWBGCOLOR "white"
#define BWFGCOLOR "black"

#define RGBPROFILE ""
#define GRAYPROFILE ""
#define CMYKPROFILE ""
#define OUTPROFILE ""

#define XYMOVE 50

/*********************  End of user configurable stuff  *********************/

#define APPNAME "imgview"
#define CLASSNAME "Imgview"
#define WINNAME "ImgView"

#define FMT_XBM 0
#define FMT_PBM 1 
#define FMT_PGM 2
#define FMT_PPM 3
#define FMT_GIF 4
#define FMT_JPEG 5
#define FMT_TIFF 6
#define FMT_PNG 7
#define FMT_PCX 8

#define FMT_JPEG_JIF 0
#define FMT_JPEG_JFIF 1
#define FMT_JPEG_EXIF 2

#define FMT_TIFF_STD 0
#define FMT_TIFF_EXIF 1

#define FILTER_NONE 6

#define MAX_FILES 32768

#define MAX_COMMENTS 64

typedef struct {
    char *key;
    char *text;
} COMMENT;

typedef struct {
    char *files[MAX_FILES];
    int nfiles, fnum;
    unsigned short si[MAX_FILES];
    struct stat statbuf;
    char cwd[FILENAME_MAX];
    char owd[FILENAME_MAX];
    int fmt, jpgfmt, tiffmt;
    int win_x, win_y, win_w, win_h;
    char bgcolor_s[256], tbgcolor_s[256];
    char bwbgcolor_s[256], bwfgcolor_s[256];
    unsigned long bgcolor, tbgcolor;
    unsigned long bwbgcolor, bwfgcolor;
    XColor bgcolor_rgb, tbgcolor_rgb;
    char rgbprofile[256];
    char grayprofile[256];
    char cmykprofile[256];
    char outprofile[256];
    cmsHPROFILE hInProfile, hOutProfile;
    cmsHPROFILE hRGBProfile, hGrayProfile, hCMYKProfile;
    cmsHTRANSFORM hTransform;
    char *iprof, *oprof;
    unsigned int iproflen, oproflen;
    double ippi[2];
    char infostr[8192];
    char xinfostr[1024];
    COMMENT comments[MAX_COMMENTS];
    int ncomments;
    char *commentstr;
    int xymove;
    int delay;
    XImage *img, *zimg, *curimg;
    int page, npages;
    int img_x, img_y;
    int zoom_w, zoom_h;
    int ulx, uly, lrx, lry, oulx, ouly, olrx, olry;
    int pad;
    GC monogc;
    int black, white;
    double zoom;
    int lockzoom, autozoom;
    int parn;
    double par;
    int lockpar, autopar;
    int rfilter;
    int slide;
    int timeout;
} VARS;

extern VARS v;

/* config.c */
void readconfig(FILE *f);

/* message.c */
FILE *messagepipe(char *title, char *font);
void message(char *title, char *s, char *font);

/* input.c */
char *input(char *title, char *prompt, char *dflt);

/* iccmisc.c */
char *proftomem(cmsHPROFILE prof, cmsUInt32Number *len);
int isoutprof(void);

/* pnm.c */
XImage *readpnm(int fd);

/* gif.c */
XImage *readgif(int fd);

/* jpeg.c */
XImage *readjpeg(int fd, int *jpegfmt);

/* tiff.c */
XImage *readtiff(int fd, char *fname, int page, int *npages, int *tiffmt);

/* png.c */
XImage *readpng(int fd);

/* pcx.c */
XImage *readpcx(int fd);

/* xbm.c */
XImage *readxbm(char *fname);

#endif
